const chatBox = document.getElementById("chat-box");
const chatBoxClose = document.getElementById("chat-box-title-close-box");
const chatBoxChat = document.getElementById("chat-box-content-chat");
const chatBoxLogin = document.getElementById("chat-box-content-login");
const emailInput = document.getElementById("email-input");
const chatButton = document.getElementById("chat-button");

let isLogin = false;
let generationUrl = "";
let sdkappid = "";
let agentID = "";

const onCloseBox = () => {
  chatBox.style.height = "0";
};

const onOpenBox = () => {
  chatBox.style.height = "600px";
}

if(chatButton){
  chatButton.addEventListener("click", onOpenBox, false);
}

if (chatBoxClose) {
  chatBoxClose.addEventListener("click", onCloseBox, false);
}

function initLoginStage(url, agent, appid) {
  generationUrl = url;
  agentID = agent;
  sdkappid = appid;
  const userID = localStorage.getItem("tencent_userId");
  if(userID) {
    login(userID, url);
  }
}

function onClickLogin() {
  const userID = emailInput.value;
  login(userID, generationUrl);
}

const login = (userID, url) => {
  if (!userID) {
    alert("Please provide a valid email address");
    return;
  }
  if(!agentID){
    alert("Please provide a valid user ID for customer support agent.");
    return;
  }
  let loginRequest = new Request(url, {
    method: "post",
    headers: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify({ userID }),
  });
  fetch(loginRequest).then((response) => {
    let result = response.text();
    result.then((res) => {
      const userSig = JSON.parse(res).userSig;
      if(userSig && userSig != ""){
        chatBoxChat.src = `https://comm.qq.com/chat?userID=${userID}&userSig=${userSig}&agentID=${agentID}&sdkappid=${sdkappid}`;
        localStorage.setItem("tencent_userId", userID);
        changeIsLogin(true);
      }
    });
  });
};

const changeIsLogin = (status) => {
  isLogin = status;
  chatBoxChat.style.display = status ? "block" : "none";
  chatBoxLogin.style.display = status ? "none" : "flex";
};
